//+------------------------------------------------------------------+
//|                                                    Envelopes.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 LightSeaGreen
#property indicator_color2 LightSeaGreen
#property indicator_color3 LightSeaGreen
#property indicator_color4 LightSeaGreen
#property indicator_color5 LightSeaGreen
#property indicator_color6 LightSeaGreen
#property indicator_color7 Gold
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_style7 STYLE_DASH




extern int    Price           = 5;
extern int    OmaLength       = 125;
extern double OmaSpeed        = 8.0;
extern bool   OmaAdaptive     = true;
extern int    AtrPeriod       = 50;
extern double AtrMultiplier.1 = 0.5;
extern double AtrMultiplier.2 = 1.0;
extern double AtrMultiplier.3 = 2.0;
extern int    OMA_Shift       = 0;



double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double stored[][7];

int    CountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   int    draw_begin;
   string short_name;

   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexShift(0,OMA_Shift);
   SetIndexShift(1,OMA_Shift);
   SetIndexShift(2,OMA_Shift);
   SetIndexShift(3,OMA_Shift);
   SetIndexShift(4,OMA_Shift);
   SetIndexShift(5,OMA_Shift);
   SetIndexShift(6,OMA_Shift);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(OmaLength<2) OmaLength=14;
   draw_begin=OmaLength-1;

   IndicatorShortName("Env("+OmaLength+")");
   SetIndexLabel(0,"Env("+OmaLength+")Upper");
   SetIndexLabel(1,"Env("+OmaLength+")Lower");
   SetIndexLabel(2,"Env("+OmaLength+")Upper1");
   SetIndexLabel(3,"Env("+OmaLength+")Lower1");
   SetIndexLabel(4,"Env("+OmaLength+")Upper2");
   SetIndexLabel(5,"Env("+OmaLength+")Lower2");
   SetIndexLabel(6,"Env("+OmaLength+")Middle");
   
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);
   SetIndexDrawBegin(3,draw_begin);
   SetIndexDrawBegin(4,draw_begin);
   SetIndexDrawBegin(5,draw_begin);
   SetIndexDrawBegin(6,draw_begin);

   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   
   OmaLength = MathMax(OmaLength,   1);
   OmaSpeed  = MathMax(OmaSpeed ,-1.5);
   
   

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i,r;
   
   if(Bars<=OmaLength) return(0);
   CountedBars=IndicatorCounted();
   if (CountedBars<0) return(-1);
   if (CountedBars>0) CountedBars--;
   limit=Bars-CountedBars;
   if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);

   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   { 
      double atr = iATR(NULL,0,AtrPeriod,i);
      double oma = iAverage(iMA(NULL,0,1,0,MODE_SMA,Price,i),OmaLength,OmaSpeed,OmaAdaptive,r,0);
         ExtMapBuffer1[i] = oma+atr*AtrMultiplier.1;
         ExtMapBuffer2[i] = oma-atr*AtrMultiplier.1;
         ExtMapBuffer3[i] = oma+atr*AtrMultiplier.2;
         ExtMapBuffer4[i] = oma-atr*AtrMultiplier.2;
         ExtMapBuffer5[i] = oma+atr*AtrMultiplier.3;
         ExtMapBuffer6[i] = oma-atr*AtrMultiplier.3;
         ExtMapBuffer7[i] = oma;
   }
   return(0);
  }
//+------------------------------------------------------------------+

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double const, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+const)/(1.0+const+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}